#ifndef ATND_H
#define ATND_H

#ifdef __BORLANDC__
#pragma warn -8004
#endif

#define VERSION 1.09
#define BUFFER_SIZE 524288 /* 512 KB */
#define COMMA ','
#define DOUBLE_BYTE 2
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 255
#define HE 0xCD /* "" Shift_JIS */
#include "line.h"
#include "numbered.h"
#include "quad_i_union.h"
#include "queue.h"

typedef void (*LINE_NUMBER_FUNCTION)(char *buffer, char *combo);

typedef struct RING_BUFFER RING_BUFFER;
struct RING_BUFFER {
    BOOL number;
    char *buffer;
    char *combo;
    int after, buffer_size, point, ring_count;
    char BELL[2];
    char file_name[FILE_NAME_SIZE];
    char new_line[3];
};

BOOL allocating(RING_BUFFER *r, char *label, int a, int before, int p, int b, BOOL n);
BOOL reading(RING_BUFFER *r);
BOOL setting(RING_BUFFER *r, char *f, int a, int before, int p, int b, BOOL n);
BOOL standard_input_output(RING_BUFFER *r);
BOOL standard_io_fields(char *label, int buffer_size, int point, int separator, BOOL measure);
BOOL standard_io_lines(char *label, int buffer_size, int point, BOOL measure);
int punctuation(char *p, int q);
void error_handler(const char *p, char *q);
void line_begins_with_number(char *buffer, char *combo);
void nonnumber(char *buffer, char *combo);
void prepare_ring(void);
void release(RING_BUFFER *r);
void show_ring(void);
void version_guide(double v, BOOL comments);

#endif /* ATND_H */
