#include "atnd.h"

/*
atnd C-1.09
Displaying lines at and around the specified point (AT and arouND)
Copyright 2019 Sogaya

Open Watcom C32 Optimizing Compiler Version 1.8 J001
gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    const BOOL LF_TO_LF_SPAN = TRUE;
    const BOOL NO_MEASURING = FALSE;
    const BOOL WITH_COMMENTS = TRUE;
    const BOOL WITHOUT_COMMENTS = FALSE;
    const int ERROR_CODE = 1;
    const int FIRST_LINE = 1;
    const int LABEL_SIZE = 2;
    const int NEW_LINE_ZERO = 2; /* buffer shall include '\n' and '\0'. */
    const int NO_RING = 1;
    const int SEPARATOR_TERM_SIZE = 2;
    char AFTER[] = "-a";
    char BEFORE[] = "-b";
    char CONTEXT[] = "-c";
    char HEAD[] = "-h";
    char INTERVAL[] = "-i";
    char LABEL[] = "-=";
    char LINE_BUFFER_SIZE[] = "-l";
    char LF[] = "-LF";
    char NUMBER[] = "-n";
    char POINT[] = "-p";
    char SEPARATOR[] = "-s";
    char SIZE_OF_BUFFER[] = "-z";
    char STANDARD_INPUT[] = "stdin";
    char TAIL[] = "-t";
    char VERSION_WITHOUT_COMMENTS[] = "-V";
    char VERSION_WITH_COMMENTS[] = "-VC";

    BOOL carriage_return = FALSE;
    BOOL line_begins_with_number = FALSE;
    BOOL line_buffer_size = FALSE;
    BOOL measure = NO_MEASURING;
    BOOL result = FALSE;
    char *buffer;
    char *edge;
    char *q;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char label[ FILE_NAME_SIZE + 1 ];
    int after = 0;
    int before = 0;
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int file_name_size = 0;
    int i, line_number, maximum, maximum_line_length, new_line_length;
    int interval_0 = 0;
    int interval_1 = 1;
    int line_count = 0;
    int point = FIRST_LINE;
    int ring_count = NO_RING;
    int separator = 0x0A;
    int tail = 0;
    NUMBERED o;
    NUMBERED *n = &o;
    RING_BUFFER ring_buffer;
    RING_BUFFER *r = &ring_buffer;

    memset(file_name, 0, FILE_NAME_SIZE);
    label[FILE_NAME_SIZE] = '\0';
    strncpy(label, STANDARD_INPUT, FILE_NAME_SIZE);

    for(i = 1; i < argc; ++i) {
        if(! strcmp(LF, argv[i]) ) {
            measure = LF_TO_LF_SPAN;
            ring_count = NO_RING;
        } else if(! strcmp(LINE_BUFFER_SIZE, argv[i]) ) {
            line_buffer_size = TRUE;
        } else if(! strcmp(NUMBER, argv[i]) ) {
            line_begins_with_number = TRUE;
        } else if(! strcmp(VERSION_WITH_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITH_COMMENTS);
        } else if(! strcmp(VERSION_WITHOUT_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argv[i];
            edge = & q[0];

            q = strstr(argv[i], AFTER);
            if(q == edge) {
                numbered(n, argv[i]);
                after = number(n);
                if(! strcmp(AFTER, parameter(n) ) ) {
                    if(after == NOT_CONVERTED) {
                        after = 0;
                    }

                    ring_count = before + 1 + after;
                    continue;
                }

                after = 0;
            }

            q = strstr(argv[i], BEFORE);
            if(q == edge) {
                numbered(n, argv[i]);
                before = number(n);
                if(! strcmp(BEFORE, parameter(n) ) ) {
                    if(before == NOT_CONVERTED) {
                        before = 0;
                    }

                    ring_count = before + 1 + after;
                    continue;
                }

                before = 0;
            }

            q = strstr(argv[i], CONTEXT);
            if(q == edge) {
                numbered(n, argv[i]);
                before = number(n);
                if(! strcmp(CONTEXT, parameter(n) ) ) {
                    if(before == NOT_CONVERTED) {
                        before = 0;
                    }

                    after = before;
                    ring_count = before + 1 + after;
                    continue;
                }

                before = 0;
            }

            q = strstr(argv[i], HEAD);
            if(q == edge) {
                numbered(n, argv[i]);
                point = number(n);
                if(! strcmp(HEAD, parameter(n) ) ) {
                    if(point == NOT_CONVERTED) {
                        point = FIRST_LINE;
                    }

                    after = 0;
                    before = point - 1;
                    ring_count = before + 1 + after;
                    continue;
                }

                point = FIRST_LINE;
            }

            q = strstr(argv[i], INTERVAL);
            if(q == edge) {
                numbered(n, argv[i]);
                interval_1 = number(n);
                if( trimmed_sequence(n) ) {
                    interval_0 = subnumber(n);
                    if(! strcmp(INTERVAL, parameter(n) ) ) {
                        if(interval_0 == NOT_CONVERTED) {
                            interval_0 = 0;
                            interval_1 = 1;
                        }

                        before = interval_1 - interval_0;
                        if(before >= 0) {
                            after = 0;
                            point = interval_1;
                            ring_count = before + 1 + after;
                            continue;
                        }

                        before = 0;
                    }

                }

                interval_0 = 0;
                interval_1 = 1;
            }

            q = strstr(argv[i], LABEL);
            if(q == edge) {
                q += LABEL_SIZE;
                label[FILE_NAME_SIZE] = '\0';
                strncpy(label, q, FILE_NAME_SIZE);
                continue;
            }

            q = strstr(argv[i], POINT);
            if(q == edge) {
                numbered(n, argv[i]);
                point = number(n);
                if(! strcmp(POINT, parameter(n) ) ) {
                    if(point == NOT_CONVERTED) {
                        point = FIRST_LINE;
                    }

                    continue;
                }

                point = FIRST_LINE;
            }

            q = strstr(argv[i], SEPARATOR);
            if(q == edge) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = strstr(argv[i], SIZE_OF_BUFFER);
            if(q == edge) {
                numbered(n, argv[i]);
                buffer_size = number(n);
                if(! strcmp(SIZE_OF_BUFFER, parameter(n) ) ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            q = strstr(argv[i], TAIL);
            if(q == edge) {
                numbered(n, argv[i]);
                tail = number(n);
                if(! strcmp(TAIL, parameter(n) ) ) {
                    if(tail == NOT_CONVERTED) {
                        tail = 0;
                    }

                    continue;
                }

                tail = 0;
            }

            file_name[FILE_NAME_SIZE] = '\0';
            strncpy(file_name, argv[i], FILE_NAME_SIZE);
        } /* if */

    } /* for(i = 1; i < argc; ++i) */

    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        if(tail > 1) {
            buffer = malloc(buffer_size);
            if(buffer == NULL) {
                fprintf(stderr, "malloc() error: %d\n", buffer_size);
                return ERROR_CODE;
            }

            line_count = standard_input_temporary_text(buffer, buffer_size);

            point = line_count;
            before = tail - 1;
            after = 0;
            ring_count = before + 1 + after;
            setting(r, TEMPORARY_TEXT, after, before, point, buffer_size, line_begins_with_number);
            result = reading(r);
            exit_code = result ? 0 : ERROR_CODE;

            release(r);
            free(buffer);
            remove(TEMPORARY_TEXT);
            return exit_code;
        }

        if(ring_count > 1) {
            allocating(r, label, after, before, point, buffer_size, line_begins_with_number);
            result = standard_input_output(r);
            release(r);
        } else {
            result = standard_io_lines(label, buffer_size, point, measure);
        }

        exit_code = result ? 0 : ERROR_CODE;
        return exit_code;
    }

    if(buffer_size == BUFFER_SIZE) {
        buffer_size = (int)file_size(file_name);
        if(buffer_size >= 0) {
            buffer_size += 1;
            buffer = malloc(buffer_size);
            if(buffer != NULL) {
                FILE *p = fopen(file_name, "rb");
                fread(buffer, buffer_size, 1, p);
                maximum = maximum_LF_to_LF_span(&line_count, &line_number, &carriage_return, buffer, buffer_size);
                new_line_length = carriage_return ? 2 : 1;
                maximum_line_length = maximum - new_line_length;
                fclose(p);
                free(buffer);

                buffer_size = maximum_line_length + NEW_LINE_ZERO;
                if(line_begins_with_number) {
                    buffer_size += FINAL_SIZE_1;
                }

            }

        } else {
            fprintf(stderr, "file_size() error: %d\n", buffer_size);
            return ERROR_CODE;
        }

    }

    if(tail > 1) {
        if(line_count == 0) {
            line_count = count_lines(file_name);
            if(line_count > 0) {
                exit_code = 0;
            } else {
                fprintf(stderr, "count_lines() error: %s\n", file_name);
                exit_code = ERROR_CODE;
                return exit_code;
            }

        }

        point = line_count;
        before = tail - 1;
        after = 0;
        ring_count = before + 1 + after;
    }

    if(line_buffer_size) {
        fprintf(stdout, "%d bytes\n", buffer_size);
    }

    if(ring_count > 1) {
        setting(r, file_name, after, before, point, buffer_size, line_begins_with_number);
        result = reading(r);
        release(r);
    } else {
        if(separator == 0x0A) {
            result = reading_lines(file_name, buffer_size, line_count, line_number, maximum_line_length, point, measure);
        } else {
            result = reading_fields(file_name, buffer_size, line_count, point, separator, measure);
        }

    }

    exit_code = result ? 0 : ERROR_CODE;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: /* 0xCD */
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
