#include "line.h"

static const int LF_SIZE = 1;

BOOL standard_io_fields(char *label, int buffer_size, int point, int separator, BOOL measure) {
    BOOL b = FALSE;
    char *data;
    char *p;
    int field_count, field_length;
    int n = 0;
    int size;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-5: %d bytes\n", buffer_size);
        return FALSE;
    }

    for(;;) {
        p = fgets(buffer, buffer_size, stdin); /* buffer includes 0Ah. */
        if(p == NULL) {
            break;
        }

        n += 1;
        if(n == point) {
            b = TRUE;
            size = strlen(buffer);
            data = malloc( size + 1 );
            strcpy(data, buffer);
        }

    }

    if(measure) {
        fprintf(stdout, "%s: %d ", label, n);
        if(n == 1) {
            fprintf(stdout, "line\n");
        } else {
            fprintf(stdout, "lines\n");
        }

        field_length = maximum_separator_to_separator_span(&field_count, buffer, size, separator);
        field_length -= SEPARATOR_SIZE;
        fprintf(stdout, "maximum separator-to-separator span of %d bytes (line-%d)\n", field_length, point);
    }

    fprintf(stdout, "%s", data);
    free(buffer);
    if(b) {
        free(data);
    }

    return b;
}

BOOL standard_io_lines(char *label, int buffer_size, int point, BOOL measure) {
    BOOL b = FALSE;
    char *data;
    char *p;
    int maximum = 0;
    int n = 0;
    int line_number, size;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-6: %d bytes\n", buffer_size);
        return FALSE;
    }

    for(;;) {
        p = fgets(buffer, buffer_size, stdin); /* buffer includes 0Ah. */
        if(p == NULL) {
            break;
        }

        n += 1;
        if(n == point) {
            b = TRUE;
            size = strlen(buffer);
            data = malloc( size + 1 );
            strcpy(data, buffer);
        }

        size = strlen(buffer);
        if(size > maximum) {
            maximum = size;
            line_number = n;
        }

    }

    if(measure) {
        fprintf(stdout, "%s: %d ", label, n);
        if(n == 1) {
            fprintf(stdout, "line\n");
        } else {
            fprintf(stdout, "lines\n");
        }

        maximum -= LF_SIZE;
        fprintf(stdout, "maximum LF-to-LF span of %d bytes (line-%d)\n", maximum, line_number);
    }

    fprintf(stdout, "%s", data);
    free(buffer);
    if(b) {
        free(data);
    }

    return b;
}
