#include "kanji_union.h"

/*
dayu C-1.07
Editing MS932~Shift_JIS.bin
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32
Digital Mars Compiler Version 8.42n (Digital Mars C/C++ Compiler Version 8.57)
Embarcadero C++ 7.30 for Win32
Open Watcom C32 Optimizing Compiler Version 1.8 J001

dayu assumes that the little-endian architecture underlies operating systems (Linux, Windows).
*/

extern SJIS_TABLE *u;

int main(int argc, char *argv[]) {
    const BOOL REMOVE_ANCIENT_FILE = FALSE;
    const BOOL WITH_COMMENTS = TRUE;
    const BOOL WITHOUT_COMMENTS = FALSE;
    const char SETTING_TEXT[] = "twenty.txt";
    const int ASCII_SIZE = 1;
    const int ASCII_TERM_SIZE = 2;
    const int ERROR_CODE = 1;
    const int KATAKANA_TERM_SIZE = 2;
    const int MS932_TERM_SIZE = 2;
    const int SJIS_TERM_SIZE = 2;
    char ACQUIRE_FROM_TEXT[] = "-q";
    char ASCII[] = "-a";
    char DIFFERENT_TIME[] = "-t-";
    char DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE[] = "-w-";
    char EDIT_TABLE[] = "-e";
    char KATAKANA[] = "-k";
    char LIST_FILE[] = "-f";
    char MS932[] = "-m";
    char NO_SKIPPING[] = "-i-";
    char READ_DOCUMENT[] = "-r";
    char SEARCH_TABLE[] = "-d-";
    char SHIFT_JIS[] = "-s";
    char VERSION_COMMENTS[] = "-VC";
    char VERSION_GUIDE[] = "-V";

    BOOL carriage_return = TRUE;
    BOOL document_to_be_read = TRUE;
    BOOL list_to_be_read = FALSE;
    BOOL edit_table = TRUE;
    BOOL identical_time = FALSE;
    BOOL no_reading = FALSE;
    BOOL no_removing = FALSE;
    BOOL no_searching = FALSE;
    BOOL priority = FALSE;
    BOOL produce_binary_file = FALSE;
    BOOL result = FALSE;
    BOOL skip_control_characters = FALSE;
    BOOL which_table = FALSE;
    char* binary_name = u->binary_name;
    char* priority_table = u->priority_table;
    char *edge;
    char *p;
    char ms932_text[ FILE_NAME_SIZE + 1 ];
    char normal[NORMAL_ARRAY_SIZE] = {0x87, 0x53, 0}; /* S */
    char sjis_text[ FILE_NAME_SIZE + 1 ];
    char substitute[SUBSTITUTE_ARRAY_SIZE] = {0x93, 0xF9, 0}; /*  */
    char text_of_substitutes_list[ FILE_NAME_SIZE + 1 ];
    int exit_code = 0;
    int file_name_size;
    int i, size;
    REGULATE regulate;
    REGULATE *r = &regulate;

    memset(ms932_text, 0, FILE_NAME_SIZE + 1 );
    memset(text_of_substitutes_list, 0,  FILE_NAME_SIZE + 1 );

    binary_name[FILE_NAME_SIZE] = '\0';
    strncpy(binary_name, MS932_SJIS_BIN, FILE_NAME_SIZE);

    sjis_text[FILE_NAME_SIZE] = '\0';
    strncpy(sjis_text, MS932_SJIS_TEXT, FILE_NAME_SIZE);

/* Acquiring parameters from SETTING_TEXT unless the user removes it. */
    acquire_parameters_from_text(SETTING_TEXT, binary_name, priority_table, ms932_text, sjis_text, normal, substitute, text_of_substitutes_list, &produce_binary_file, &carriage_return, &no_searching, &edit_table, &skip_control_characters, &no_reading, &identical_time, &which_table, &no_removing);

    for(i = 1; i < argc; ++i) {
        if(! strcmp(argv[i], ACQUIRE_FROM_TEXT) ) {
            priority = TRUE;
        } else if(! strcmp(argv[i], CRLF) ) {
            carriage_return = TRUE;
        } else if(! strcmp(argv[i], DIFFERENT_TIME) ) {
            identical_time = FALSE;
        } else if(! strcmp(argv[i], DO_NOT_REMOVE_0DH) ) {
            carriage_return = TRUE;
        } else if(! strcmp(argv[i], DO_NOT_REMOVE_TEMPORARY_BINARY_FILE) ) {
            no_removing = TRUE;
        } else if(! strcmp(argv[i], DO_NOT_SEARCH_TABLE) ) {
            no_searching = TRUE;
        } else if(! strcmp(argv[i], DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE) ) {
            which_table = FALSE;
        } else if(! strcmp(argv[i], EDIT_TABLE) ) {
            edit_table = TRUE;
        } else if(! strcmp(argv[i], IDENTICAL_TIME) ) {
            identical_time = TRUE;
        } else if(! strcmp(argv[i], LF) ) {
            carriage_return = FALSE;
        } else if(! strcmp(argv[i], LINE_FEED) ) {
            carriage_return = FALSE;
        } else if(! strcmp(argv[i], LIST_FILE) ) {
            list_to_be_read = TRUE;
        } else if(! strcmp(argv[i], NO_EDITING) ) {
            edit_table = FALSE;
        } else if(! strcmp(argv[i], NO_READING) ) {
            no_reading = TRUE;
        } else if(! strcmp(argv[i], NO_SKIPPING) ) {
            skip_control_characters = FALSE;
        } else if(! strcmp(argv[i], READ_DOCUMENT) ) {
            no_reading = FALSE;
        } else if(! strcmp(argv[i], SEARCH_TABLE) ) {
            no_searching = FALSE;
        } else if(! strcmp(argv[i], SKIPPING) ) {
            skip_control_characters = TRUE;
        } else if(! strcmp(argv[i], TEMPORARY_BINARY_FILE) ) {
            produce_binary_file = TRUE;
        } else if(! strcmp(argv[i], VERSION_COMMENTS) ) {
            version_guide(VERSION_NUMBER, WITH_COMMENTS);
        } else if(! strcmp(argv[i], VERSION_GUIDE) ) {
            version_guide(VERSION_NUMBER, WITHOUT_COMMENTS);
        } else if(! strcmp(argv[i], WHICH_TABLE) ) {
            which_table = TRUE;
        } else {
            p = argv[i];
            edge = & p[0];

            p = strstr(argv[i], ASCII);
            if(p == edge) {
                memset(substitute, 0, SUBSTITUTE_ARRAY_SIZE);
                p = & argv[i][ASCII_TERM_SIZE];
                memcpy(substitute, p, ASCII_SIZE);
                continue;
            }

            p = strstr(argv[i], SHIFT_JIS);
            if(p == edge) {
                memset(substitute, 0, SUBSTITUTE_ARRAY_SIZE);
                p = & argv[i][SJIS_TERM_SIZE];
                memcpy(substitute, p, SJIS_KANJI_SIZE);
                continue;
            }

            p = strstr(argv[i], KATAKANA);
            if(p == edge) {
                memset(normal, 0, NORMAL_ARRAY_SIZE);
                p = & argv[i][KATAKANA_TERM_SIZE];
                memcpy(normal, p, KATAKANA_SIZE);
                continue;
            }

            p = strstr(argv[i], MS932);
            if(p == edge) {
                memset(normal, 0, NORMAL_ARRAY_SIZE);
                p = & argv[i][MS932_TERM_SIZE];
                memcpy(normal, p, SJIS_KANJI_SIZE);
                continue;
            }

            if(list_to_be_read) {
                text_of_substitutes_list[FILE_NAME_SIZE] = '\0';
                strncpy(text_of_substitutes_list, argv[i], FILE_NAME_SIZE);
                list_to_be_read = FALSE;
            } else {
                if(document_to_be_read) {
                    ms932_text[FILE_NAME_SIZE] = '\0';
                    strncpy(ms932_text, argv[i], FILE_NAME_SIZE);
                    document_to_be_read = FALSE;
                } else {
                    sjis_text[FILE_NAME_SIZE] = '\0';
                    strncpy(sjis_text, argv[i], FILE_NAME_SIZE);
                }

            }

        } /* else */

    } /* for(i = 1; i < argc; ++i) */

    if(edit_table) {
        size = strlen(text_of_substitutes_list);
        if(size == 0) {
            result = edit_record(normal, substitute, binary_name, no_searching, priority, &which_table);
        } else {
            result = edit_many_records(text_of_substitutes_list, binary_name, no_searching, priority, &which_table);
        }

        if(result) {
            if(no_reading) {
                return 0;
            }

        } else {
            return ERROR_CODE;
        }

    }

    if(! allocating(r, ms932_text, no_searching, which_table) ) {
        return ERROR_CODE;
    }

    file_name_size = strlen(ms932_text);
    if(file_name_size == 0) {
        if(skip_control_characters) {
            exit_code = standard_input_output_skipping(r);
        } else {
            exit_code = standard_input_output(r);
        }

    } else {
        if(! open_close(ms932_text) ) {
            fprintf(stderr, "open_close() error: %s\n", ms932_text);
        }

        if(identical_time) {
            produce_temporary_binary_file(ms932_text, REMOVE_ANCIENT_FILE);
            rename_binary_file(ms932_text, no_removing);
        }

        if(produce_binary_file) {
            if(carriage_return) {
                if(skip_control_characters) {
                    exit_code = skipping_control_characters_to_produce_SJIS(r, TEMPORARY_BINARY);
                } else {
                    exit_code = reading_to_produce_SJIS(r, TEMPORARY_BINARY);
                }

            } else {
                if(skip_control_characters) {
                    exit_code = skipping_control_characters_to_produce_SJIS_LF(r, TEMPORARY_BINARY);
                } else {
                    exit_code = reading_to_produce_SJIS_LF(r, TEMPORARY_BINARY);
                }

            }

            rename_binary_file(sjis_text, no_removing);
        } else {
            if(carriage_return) {
                if(skip_control_characters) {
                    exit_code = skipping_control_characters_to_produce_SJIS(r, sjis_text);
                } else {
                    exit_code = reading_to_produce_SJIS(r, sjis_text);
                }

            } else {
                if(skip_control_characters) {
                    exit_code = skipping_control_characters_to_produce_SJIS_LF(r, sjis_text);
                } else {
                    exit_code = reading_to_produce_SJIS_LF(r, sjis_text);
                }

            }

        }

    }

    return exit_code;
}

/*
1:  MS932~Shift_JIS.bin	table
2:  KeyWords.csv		MS932
3:  dayu.txt		Shift_JIS
4:  S			normal
5:  			substitute
6:  			bars.txt
7:  0			-b
8:  -CRLF			-CRLF
9:  0			-d
10: 0			-e-
11: 0			-i
12: 0			-r-
13: 0			-t
14: 0			-w
15: 0			-y
16: C:\MS932~Shift_JIS.bin	priority
*/

void acquire_parameters_from_text(const char *parameters_text, char *binary_name, char *priority_table, char *document_name, char *new_name, char *normal, char *substitute, char *text_of_substitutes_list, BOOL *produce_binary_file, BOOL *carriage_return, BOOL *no_searching, BOOL *edit_table, BOOL *skip_control_characters, BOOL *no_reading, BOOL *identical_time, BOOL *which_table, BOOL *no_removing) {
    char *p;
    char c[C_SIZE];
    FILE *setting = fopen(parameters_text, "rt");
    int k;
    int line_number = 0;

    if(setting != NULL) {
        for(;;) {
            p = fgets(c, C_SIZE, setting);
            if(p == NULL) {
                break;
            } else {
                k = strcspn(c, "\n'|\t");
                c[k] = '\0';
            }

            line_number += 1;
            switch(line_number) {
            case 1:
                strcpy(binary_name, c); /* MS932~Shift_JIS.bin */
                break;
            case 2:
                strcpy(document_name, c); /* KeyWords.csv */
                break;
            case 3:
                strcpy(new_name, c); /* dayu.txt */
                break;
            case 4:
                strcpy(normal, c); /* S */
                break;
            case 5:
                strcpy(substitute, c); /*  */
                break;
            case 6:
                strcpy(text_of_substitutes_list, c); /* bars.txt */
                break;
            case 7:
                if(! strcmp(TEMPORARY_BINARY_FILE, c) ) { /* -b */
                    *produce_binary_file = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *produce_binary_file = FALSE;
                } else {
                    *produce_binary_file = TRUE;
                }

                break;
            case 8:
                if(! strcmp(CRLF, c) ) { /* -CRLF */
                    *carriage_return = TRUE;
                } else if(! strcmp(DO_NOT_REMOVE_0DH, c) ) { /* -L- */
                    *carriage_return = TRUE;
                } else if(! strcmp(LF, c) ) { /* -LF */
                    *carriage_return = FALSE;
                } else if(! strcmp(LINE_FEED, c) ) { /* -L */
                    *carriage_return = FALSE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *carriage_return = FALSE;
                } else {
                    *carriage_return = TRUE;
                }

                break;
            case 9:
                if(! strcmp(DO_NOT_SEARCH_TABLE, c) ) { /* -d */
                    *no_searching = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *no_searching = FALSE;
                } else {
                    *no_searching = TRUE;
                }

                break;
            case 10:
                if(! strcmp(NO_EDITING, c) ) { /* -e- */
                    *edit_table = FALSE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *edit_table = TRUE;
                } else {
                    *edit_table = FALSE;
                }

                break;
            case 11:
                if(! strcmp(SKIPPING, c) ) { /* -i */
                    *skip_control_characters = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *skip_control_characters = FALSE;
                } else {
                    *skip_control_characters = TRUE;
                }

                break;
            case 12:
                if(! strcmp(NO_READING, c) ) { /* -r- */
                    *no_reading = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *no_reading = FALSE;
                } else {
                    *no_reading = TRUE;
                }

                break;
            case 13:
                if(! strcmp(IDENTICAL_TIME, c) ) { /* -t */
                    *identical_time = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *identical_time = FALSE;
                } else {
                    *identical_time = TRUE;
                }

                break;
            case 14:
                if(! strcmp(WHICH_TABLE, c) ) { /* -w */
                    *which_table = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *which_table = FALSE;
                } else {
                    *which_table = TRUE;
                }

                break;
            case 15:
                if(! strcmp(DO_NOT_REMOVE_TEMPORARY_BINARY_FILE, c) ) { /* -y */
                    *no_removing = TRUE;
                } else if(! strcmp(ZERO, c) ) { /* 0 */
                    *no_removing = FALSE;
                } else {
                    *no_removing = TRUE;
                }

                break;
            case 16:
                strcpy(priority_table, c); /* C:\MS932~Shift_JIS.bin */
                break;
            default:
                break;
            } /* switch(line_number) */

        } /* for(;;) */

        fclose(setting);
    } /* if(setting != NULL) */

}
