#ifndef KANJI_UNION_H
#define KANJI_UNION_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION_NUMBER 1.07
#define BELL 0x07
#define BELL_ASCII_KATAKANA_COUNT 224
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 524288 /* 512 KB */
#define C_MS932_SJIS_BIN "C:\\sortk-C\\MS932~Shift_JIS.bin"
#define C_SIZE 256 /* FILE_NAME_SIZE + 1 */
#define CRLF "-CRLF"
#define COMBO_SIZE 39424
#define DATA_ARRAY_LIMIT 906
#define DO_NOT_REMOVE_0DH "-L-"
#define DO_NOT_REMOVE_TEMPORARY_BINARY_FILE "-y"
#define DO_NOT_SEARCH_TABLE "-d"
#define DOUBLE_KANJI 4 /* SJIS_KANJI_SIZE + SJIS_KANJI_SIZE */
#define DUAL_KANJI 4 /* SJIS_KANJI_SIZE + SJIS_KANJI_SIZE */
#define ERROR_TEXT "error.txt"
#define FILE_ERROR_CODE -2
#define FILE_NAME_SIZE 255
#define FIRST_KANJI 159
#define IDENTICAL_TIME "-t"
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KANJI_SIZE 2
#define KATAKANA_SIZE 1
#define LF "-LF"
#define LINE_FEED "-L"
#define MS932_SJIS_BIN "MS932~Shift_JIS.bin"
#define MS932_SJIS_TEXT "dayu.txt"
#define NO_EDITING "-e-"
#define NO_READING "-r-"
#define NORMAL_ARRAY_SIZE 3
#define RECORD_COUNT 7882
#define RIGHT_ARROW "" /* Shift_JIS */
#define SEARCH_COUNT 4
#define SJIS_KANJI_SIZE 2
#define SJIS_KANJI_SIZE_1 3
#define SKIPPING "-i"
#define SUBSTITUTE_ARRAY_SIZE 3
#define TEMPORARY_BINARY "binary.tmp"
#define TEMPORARY_BINARY_FILE "-b"
#define WHICH_TABLE "-w"
#define ZERO "0"
#include "dividing.h"

typedef struct REGULATE REGULATE;
struct REGULATE {
    BOOL carriage_return, no_searching, which_table;
    char *buffer;
    char *combo;
    char document_name[ FILE_NAME_SIZE + 1 ];
};

typedef BOOL (*OPEN_CLOSE_FUNCTION)(char *buffer, int buffer_size);

typedef struct SJIS_TABLE SJIS_TABLE;
struct SJIS_TABLE {
    BOOL priority;
    char binary_name[ FILE_NAME_SIZE + 1 ];
    char priority_table[ FILE_NAME_SIZE + 1 ];
    char combo[4];
    char *table;
    int size;
};

typedef union KANJI KANJI;
union KANJI {
    unsigned char sequence[6];
    unsigned short code[3];
    unsigned int block;
};

typedef struct NORMAL_SUBSTITUTE NORMAL_SUBSTITUTE;
struct NORMAL_SUBSTITUTE {
    BOOL please_check;
    char normal[NORMAL_ARRAY_SIZE];
    char substitute[SUBSTITUTE_ARRAY_SIZE];
};

BOOL allocating(REGULATE *r, char *d, BOOL n, BOOL w);
BOOL edit_many_records(char *text, char *binary_name, BOOL no_searching, BOOL priority, BOOL *which_table);
BOOL edit_record(char *normal, char *substitute, char *binary_name, BOOL no_searching, BOOL priority, BOOL *which_table);
BOOL ms932_sjis_file_in_current_directory(char *buffer, int buffer_size);
BOOL ms932_sjis_file_in_installed_directory(char *buffer, int buffer_size);
BOOL ms932_sjis_file_in_path_directory(char *buffer, int buffer_size);
BOOL ms932_sjis_file_in_specified_directory(char *buffer, int buffer_size);
BOOL open_close(char *file_name);
BOOL setting(SJIS_TABLE *u, BOOL no_searching, BOOL *which_table);
char *growing(SJIS_TABLE *u, int index);
int inverted(char *c);
int produce_temporary_binary_file(const char *name, BOOL no_removing);
int reading_to_produce_SJIS(REGULATE *r, char *new_name);
int reading_to_produce_SJIS_LF(REGULATE *r, char *new_name);
int rename_binary_file(const char *name, BOOL no_removing);
int skipping_control_characters_to_produce_SJIS(REGULATE *r, char *new_name);
int skipping_control_characters_to_produce_SJIS_LF(REGULATE *r, char *new_name);
int standard_input_output(REGULATE *r);
int standard_input_output_skipping(REGULATE *r);
unsigned char working(SJIS_TABLE *u, int index, int place);
void acquire_parameters_from_text(const char *parameters_text, char *binary_name, char *priority_table, char *document_name, char *new_name, char *normal, char *substitute, char *text_of_substitutes_list, BOOL *produce_binary_file, BOOL *carriage_return, BOOL *no_searching, BOOL *edit_table, BOOL *skip_control_characters, BOOL *no_reading, BOOL *identical_time, BOOL *which_table, BOOL *no_removing);
void clear_table(SJIS_TABLE *u);
void detach_table(SJIS_TABLE *u);
void error_handler(const char *p, const char *q);
void path_name(char *data, char *extra, char *buffer, int buffer_size);
void populated(SJIS_TABLE *u, int index, int place, char c);
void release_buffers(REGULATE *r);
void version_guide(double v, BOOL comments);

#endif /* KANJI_UNION_H */
