#include "kanji_union.h"

extern SJIS_TABLE *u;
static int ERROR_CODE = 1;

int reading_to_produce_SJIS(REGULATE *r, char *new_name) {
    BOOL *which = & r->which_table;
    BOOL kanji = FALSE;
    char *p;
    char a[3] = {0, 0, 0};
    int c, k, m;
    int exit_code = 0;
    FILE *file;
    unsigned char uc;
    unsigned char first_byte = 0x40;
    FILE *new_file = fopen(new_name, "wb");
    if(new_file == NULL) {
        new_file = fopen(MS932_SJIS_TEXT, "wb");
    }

    if(! setting(u, r->no_searching, which) ) {
        error_handler("reading_to_produce_SJIS() error:", "setting(u, r->no_searching, which)");
        return ERROR_CODE;
    }

    file = fopen(r->document_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error-1: %s\n", r->document_name);
        return ERROR_CODE;
    }

    for(;;) {
        p = fgets(r->buffer, BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        } else {
            p = strchr(r->buffer, '\n');
            if(p != NULL) {
                *p = '\0';
            }

            k = 0;
        }

        for(m = 0; r->buffer[m]; m++) {
            uc = (unsigned char)r->buffer[m];
            c = (int)uc;

            if(kanji) {
                a[0] = (char)first_byte;
                a[1] = (char)uc;
                r->combo[k] = working(u, inverted(a), 0);
                r->combo[ k + 1 ] = working(u, inverted(a), 1);
                k += SJIS_KANJI_SIZE;
                kanji = FALSE;
                continue;
            }

            if(0x81 <= c && c<= 0xFC) {
                if(KANA_KUTEN <= c && c <= KANA_HANDAKUTEN) {
                    r->combo[k] = working(u, c, 0);
                    k += KATAKANA_SIZE;
                    kanji = FALSE;
                } else {
                    first_byte = uc;
                    kanji = TRUE;
                }

            } else {
                r->combo[k++] = (char)uc;
                kanji = FALSE;
            }

        }

        r->combo[k++] = 0x0D;
        r->combo[k++] = 0x0A;
        fwrite(r->combo, k, 1, new_file);
    }

    fclose(file);
    fclose(new_file);
    detach_table(u);
    release_buffers(r);
    return exit_code;
}

int reading_to_produce_SJIS_LF(REGULATE *r, char *new_name) {
    BOOL *which = & r->which_table;
    BOOL kanji = FALSE;
    char *p;
    char a[3] = {0, 0, 0};
    int c, k, m;
    int exit_code = 0;
    FILE *file;
    unsigned char uc;
    unsigned char first_byte = 0x40;
    FILE *new_file = fopen(new_name, "wb");
    if(new_file == NULL) {
        new_file = fopen(MS932_SJIS_TEXT, "wb");
    }

    if(! setting(u, r->no_searching, which) ) {
        error_handler("reading_to_produce_SJIS() error:", "setting(u, r->no_searching, which)");
        return ERROR_CODE;
    }

    file = fopen(r->document_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error-1: %s\n", r->document_name);
        return ERROR_CODE;
    }

    for(;;) {
        p = fgets(r->buffer, BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        } else {
            p = strchr(r->buffer, '\n');
            if(p != NULL) {
                *p = '\0';
            }

            k = 0;
        }

        for(m = 0; r->buffer[m]; m++) {
            uc = (unsigned char)r->buffer[m];
            c = (int)uc;

            if(kanji) {
                a[0] = (char)first_byte;
                a[1] = (char)uc;
                r->combo[k] = working(u, inverted(a), 0);
                r->combo[ k + 1 ] = working(u, inverted(a), 1);
                k += SJIS_KANJI_SIZE;
                kanji = FALSE;
                continue;
            }

            if(0x81 <= c && c<= 0xFC) {
                if(KANA_KUTEN <= c && c <= KANA_HANDAKUTEN) {
                    r->combo[k] = working(u, c, 0);
                    k += KATAKANA_SIZE;
                    kanji = FALSE;
                } else {
                    first_byte = uc;
                    kanji = TRUE;
                }

            } else {
                r->combo[k++] = (char)uc;
                kanji = FALSE;
            }

        }

        r->combo[k++] = 0x0A;
        fwrite(r->combo, k, 1, new_file);
    }

    fclose(file);
    fclose(new_file);
    detach_table(u);
    release_buffers(r);
    return exit_code;
}

BOOL allocating(REGULATE *r, char *d, BOOL n, BOOL w) {
    BOOL allocated = TRUE;

    strcpy(r->document_name, d);
    r->no_searching = n;
    r->which_table = w;
    r->buffer = malloc(BUFFER_SIZE);
    if(r->buffer == NULL) {
        fprintf(stderr, "malloc() error-13: %d bytes", BUFFER_SIZE);
        allocated = FALSE;
    }

    r->combo = malloc(BUFFER_SIZE);
    if(r->combo == NULL) {
        fprintf(stderr, "r->combo == NULL error: %d bytes", BUFFER_SIZE);
        allocated = FALSE;
    }

    return allocated;
}

void release_buffers(REGULATE *r) {
    free(r->buffer);
    free(r->combo);
}
