#ifndef KEYUN_H
#define KEYUN_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#pragma warn -8071
#endif

#define VERSION 1.022
#define BLOCK_SIZE 3072
#define C_SIZE 256 /* FILE_NAME_SIZE + 1 */
#define DOUBLE_ARRAY_SIZE 10
#define END 80 /* SIZE_OF_DOUBLE * DOUBLE_ARRAY_SIZE = END */
#define END_1 79
#define END_ID 91 /* END + WIDE_SPACE_SIZE */
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 255
#define INTEGER_ARRAY_SIZE 20
#define LIMIT_OF_MY_MEMORY 128
#define LINE_ID INTEGER_ARRAY_SIZE
#define MAXIMUM_SIZE_OF_ENCODED_PATTERN 641 /* END * 8 bits + 1 */
#define KEYUN_TEXT "keyun.txt"
#define PATTERN_OF_32_BITS 32
#define RECORD_SIZE BLOCK_SIZE
#define SIZE_OF_DOUBLE 8 /* sizeof(double) = 8 */
#define TEMPORARY_BINARY "binary.tmp"
#define WIDE_SPACE_SIZE 11 /* FINAL_SIZE_1 */
#define ZERO "0"

#define ADD_ID "-#"
#define CRLF "-CRLF"
#define DESCENDING "-r"
#define DO_NOT_REMOVE_0DH "-L-"
#define DO_NOT_REMOVE_TEMPORARY_BINARY_FILE "-y"
#define LF "-LF"
#define LINE_FEED "-L"
#define LINE_FOR_EACH_UNIQUE_SUMMARY "-u"
#define NOT_CASE_SENSITIVE "-f"
#define REPORT_ID "-!"
#define SILENT "-s"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bool_true.h"

enum LIST_OF_FUNCTIONS {
    PHRASES,
    INTEGERS,
    FLOATING_POINT_NUMBERS,
    FUNCTION_COUNT
};

typedef union DOUBLE_UNION DOUBLE_UNION;
union DOUBLE_UNION {
    char c[BLOCK_SIZE];
    double d[DOUBLE_ARRAY_SIZE];
    int n[ INTEGER_ARRAY_SIZE + 1 ];
};

BOOL producing(char *new_name, char *records_list, int end, int line_count, int record_size, BOOL carriage_return);
int arranging_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, BOOL add_ID, BOOL carriage_return, BOOL case_sensitive, BOOL descending);
int arranging_unique_lines_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, BOOL add_ID, BOOL carriage_return, BOOL case_sensitive, BOOL descending);
int case_insensitive_comparison(const void *x, const void *y);
int case_insensitive_comparison_descending(const void *x, const void *y);
int compare_doubles(const void *x, const void *y);
int compare_doubles_descending(const void *x, const void *y);
int compare_integers(const void *x, const void *y);
int compare_integers_descending(const void *x, const void *y);
int compare_phrases(const void *x, const void *y);
int compare_phrases_descending(const void *x, const void *y);
int run_length_encoding(DOUBLE_UNION *u, char *combo, int combo_size);
void acquire_parameters_from_text(const char *parameters_text, char *file_name, char *new_name, int *line_count, int *manager, int *record_size, BOOL *add_ID, BOOL *case_sensitive, BOOL *report_ID, BOOL *carriage_return, BOOL *descending, BOOL *loud, BOOL *remove_temporary_binary_file, BOOL *unique_summary);
void display_records(char *records_list, int end, int line_count, int record_size);
void error_handler(const char *p, char *q);
void version_guide(double v, BOOL comments, BOOL loud);

#endif /* KEYUN_H */
