#include "keyun.h"

static int NEW_PATTERN_BEGINS_WITH_SET_BIT = 1;

int run_length_encoding(DOUBLE_UNION *u, char *combo, int combo_size) {
    char set_bit = NEW_PATTERN_BEGINS_WITH_SET_BIT; // Because run_length_encoding() adds a set bit to the pattern, a decoder shall omit the set bit.
    char clear_bit = 0;
    int b, i, k, m;
    int n = 0;
    unsigned int msb = 0x80000000;
    const int MSB = (int)msb;

    memset(combo, 0, combo_size);
    for(k = 0; k < INTEGER_ARRAY_SIZE; ++k) {
        m = u->n[k];

        for(i = 0; i < PATTERN_OF_32_BITS; ++i) {
            b = m & MSB;
            if(b == MSB) {
                if(clear_bit) {
                    combo[n++] = clear_bit;
                    clear_bit = 0;
                }

                set_bit += 1;
            } else {
                if(set_bit) {
                    combo[n++] = set_bit;
                    set_bit = 0;
                }

                clear_bit += 1;
            }

            m = m << 1;
        }

    }

    if(clear_bit) {
        combo[n++] = clear_bit;
    }

    if(set_bit) {
        combo[n++] = set_bit;
    }

    return n;
}

