#include "obot.h"

/*
obot C-1.07
Copyright 2019 Sogaya
Reading and writing so that the first part of EXE can be represented in hexadecimal as 4D 5A, for example.

Open Watcom C32 Optimizing Compiler Version 1.8 J001
gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    const BOOL WITH_COMMENTS = TRUE;
    const BOOL WITHOUT_COMMENTS = FALSE;
    const int BUFFER_SIZE = 640;
    const int ERROR_CODE = 1;
    const int GAP = ' ';
    const int SEPARATOR_TERM_SIZE = 2;
    const int UPPER_LIMIT = 3;
    char DO_NOT_REMOVE_TEMPORARY_FILE[] = "-y";
    char FIELD_COUNT_TERM[] = "-c";
    char LINES_OF_FILE[] = "-m";
    char READ_BUFFER[] = "-b";
    char ROWS_OF_TABLE[] = "-r";
    char SEPARATOR[] = "-s";
    char VERSION_WITHOUT_COMMENTS[] = "-V";
    char VERSION_WITH_COMMENTS[] = "-VC";

    BOOL count_LF = FALSE;
    BOOL no_removing = FALSE;
    char *edge;
    char *large_buffer;
    char *q;
    char file_name[ FILE_NAME_SIZE + 1 ];
    HEXADECIMAL_FIELDS hexadecimal_fields;
    HEXADECIMAL_FIELDS *h = &hexadecimal_fields;
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int file_name_size = 0;
    int i;
    int limit = UPPER_LIMIT;
    int line_count = 0;
    int maximum_row_number = FINAL;
    int separator = GAP;
    NUMBERED o;
    NUMBERED *n = &o;

    memset(file_name, 0, FILE_NAME_SIZE + 1 );

/* Acquiring parameters from SETTING_TEXT unless the user removes it. */
    acquire_parameters_from_text(SETTING_TEXT, file_name, &buffer_size, &limit, &separator, &field_count, &maximum_row_number);

    for(i = 1; i < argc; ++i) {
        if(! strcmp(COUNT_LF, argv[i]) ) {
            count_LF = TRUE;
        } else if(! strcmp(DO_NOT_REMOVE_TEMPORARY_FILE, argv[i]) ) {
            no_removing = TRUE;
        } else if(! strcmp(VERSION_WITH_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITH_COMMENTS);
        } else if(! strcmp(VERSION_WITHOUT_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argv[i];
            edge = & q[0];

            q = strstr(argv[i], FIELD_COUNT_TERM);
            if(q == edge) {
                numbered(n, argv[i]);
                field_count = number(n);
                if(! strcmp(FIELD_COUNT_TERM, parameter(n) ) ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = strstr(argv[i], LINES_OF_FILE);
            if(q == edge) {
                numbered(n, argv[i]);
                limit = number(n);
                if(! strcmp(LINES_OF_FILE, parameter(n) ) ) {
                    if(limit == NOT_CONVERTED) {
                        limit = UPPER_LIMIT;
                    }

                    continue;
                }

                limit = UPPER_LIMIT;
            }

            q = strstr(argv[i], READ_BUFFER);
            if(q == edge) {
                numbered(n, argv[i]);
                buffer_size = number(n);
                if(! strcmp(READ_BUFFER, parameter(n) ) ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            q = strstr(argv[i], ROWS_OF_TABLE);
            if(q == edge) {
                numbered(n, argv[i]);
                maximum_row_number = number(n);
                if(! strcmp(ROWS_OF_TABLE, parameter(n) ) ) {
                    if(buffer_size == NOT_CONVERTED) {
                        maximum_row_number = FINAL;
                    }

                    continue;
                }

                maximum_row_number = FINAL;
            }

            q = strstr(argv[i], SEPARATOR);
            if(q == edge) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            file_name[FILE_NAME_SIZE] = '\0';
            strncpy(file_name, argv[i], FILE_NAME_SIZE);
        } /* else */

    } /* for(i = 1; i < argc; ++i) */

    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        large_buffer = malloc(LARGE_BUFFER_SIZE);
        if(large_buffer == NULL) {
            fprintf(stderr, "malloc() error: %d\n", large_buffer);
            return ERROR_CODE;
        }

        line_count = standard_input_temporary_text(large_buffer, LARGE_BUFFER_SIZE);

        free(large_buffer);
        strcpy(file_name, TEMPORARY_TEXT);
    }

    if(count_LF) {
        line_count = count_lines(file_name);
        if(line_count > 0) {
            fprintf(stdout, "%d lines\n", line_count);
            exit_code = 0;
        } else {
            fprintf(stderr, "count_lines() error: %s\n", file_name);
            exit_code = ERROR_CODE;
        }

        return exit_code;
    }

    if(! setting(h, file_name, buffer_size, field_count, limit, separator) ) {
        return ERROR_CODE;
    }

    exit_code = represented_in_hexadecimal(h);
    release(h);
    if(line_count > 0) {
        if(! no_removing) {
            remove(TEMPORARY_TEXT);
        }

    }

    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: /* 0xCD */
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
