#include "sutai.h"

static const int ERROR_CODE = -1;

int counting(SELECTED *t, char *file_name, char *bits, long z, int separator, int field_count, int joint, int quote, int upper_limit, BOOL remove_separators) {
    char *buffer;
    char *p;
    char few_fields;
    int buffer_size = (int)z;
    int f, shared_field_count;
    SEGMENTED s;
    SEGMENTED *d = &s;
    FILE *file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error-4: %s\n", file_name);
        t->exit_code = 1;
        return ERROR_CODE;
    }

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;
    t->line_count = 0;

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-4: %d bytes\n", buffer_size);
        t->exit_code = 2;
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            t->exit_code = 3;
            return ERROR_CODE;
        }

        full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
        shared_field_count = segmented_summary(d, buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            t->line_count += 1;
            if(t->line_count > upper_limit) {
                break;
            }

            full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
            f = segmented_summary(d, buffer);
            if(f != shared_field_count) {
                fputs(buffer, stdout);
            }

            release_arrays(d);
        }

    } else {
        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            t->exit_code = 4;
            return ERROR_CODE;
        }

        connecting_fields(d, bits, z, separator, field_count, remove_separators);
        shared_field_count = segmented_summary(d, buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            t->line_count += 1;
            if(t->line_count > upper_limit) {
                break;
            }

            connecting_fields(d, bits, z, separator, field_count, remove_separators);
            f = segmented_summary(d, buffer);
            if(f != shared_field_count) {
                fputs(buffer, stdout);
            }

            release_arrays(d);
        }

    }

    fclose(file);
    free(buffer);
    return t->line_count;
}

int standard_input_counting(SELECTED *t, char *bits, long z, int separator, int field_count, int joint, int quote, int upper_limit, BOOL remove_separators) {
    char *buffer;
    char *p;
    char few_fields;
    SEGMENTED s;
    SEGMENTED *d = &s;
    int buffer_size = (int)z;
    int f, shared_field_count;

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;
    t->line_count = 0;

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-5: %d bytes\n", buffer_size);
        t->exit_code = 5;
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            t->exit_code = 6;
            return ERROR_CODE;
        }

        full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
        shared_field_count = segmented_summary(d, buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            t->line_count += 1;
            if(t->line_count > upper_limit) {
                break;
            }

            full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
            f = segmented_summary(d, buffer);
            if(f != shared_field_count) {
                fputs(buffer, stdout);
            }

            release_arrays(d);
        }

    } else {
        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            t->exit_code = 7;
            return ERROR_CODE;
        }

        connecting_fields(d, bits, z, separator, field_count, remove_separators);
        shared_field_count = segmented_summary(d, buffer);

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            t->line_count += 1;
            if(t->line_count > upper_limit) {
                break;
            }

            connecting_fields(d, bits, z, separator, field_count, remove_separators);
            f = segmented_summary(d, buffer);
            if(f != shared_field_count) {
                fputs(buffer, stdout);
            }

            release_arrays(d);
        }

    }

    free(buffer);
    return t->line_count;
}
