#include "sutai.h"

void version_guide(double v, BOOL comments, BOOL loud) {
    char combo[BLOCK_SIZE];

    combo[0] = '\0';
    sprintf(combo, "sortk C-%1.3f\n\n", v);

    if(comments) {
        strcat(combo, "sortk -t, -o new csv      # Read csv to produce a new file. \n");
        strcat(combo, "sortk -t, < csv > new     # Read csv to produce a new file. \n");
        strcat(combo, "sortk -t, -a4 -h1011 csv  # Compare in Field-1, Field-3 and Field-4. \n");
        strcat(combo, "sortk -t, -j2 csv         # Compare phrases in Field-2. \n");
        strcat(combo, "sortk -t, -k2,2 csv       # Compare phrases in Field-2. \n");
        strcat(combo, "sortk -t, -k2,3 csv       # Compare phrases from Field-2 to Field-3. \n");
        strcat(combo, "sortk -t, -k2 csv         # Compare phrases from Field-2 to finish. \n");
        strcat(combo, "sortk -t, -k1 -$ csv      # Check if all lines share the field count. \n");
        strcat(combo, "sortk -t, -k2,2 -# csv    # Add ID to each summary. \n");
        strcat(combo, "sortk -t, -k2,3 -# -! csv # Report ID if any summaries match each other. \n");
        strcat(combo, "sortk -t, -k2,2 -8 csv    # UTF-8 \n");
        strcat(combo, "sortk -t, -k2,2 -b csv    # Skip space in the first part of Field-2. \n");
        strcat(combo, "sortk -t, -k2,2 -c- csv   # Skip combining characters. \n");
        strcat(combo, "sortk -t, -k2,2 -e csv    # EUC-JP \n");
        strcat(combo, "sortk -t, -k2,2 -f csv    # EIGHT equals eight. \n");
        strcat(combo, "sortk -t, -k2,2 -g csv    # Compare 0.12 with 0.78 in Field-2. \n");
        strcat(combo, "sortk -t, -k2,2 -i csv    # Skip control characters. \n");
        strcat(combo, "sortk -t, -k2,2 -l csv    # Show how large the buffer is. \n");
        strcat(combo, "sortk -t, -k2,2 -n csv    # Compare 3456 with 9012 in Field-2. \n");
        strcat(combo, "sortk -t, -k2,2 -p csv    # P and Q are omitted from ASCII characters. \n");
        strcat(combo, "sortk -t, -k2,2 -q csv    # Commas disappear if placed in quotes. \n");
        strcat(combo, "sortk -t, -k2,2 -r csv    # Arrange in descending order. \n");
        strcat(combo, "sortk -t, -k2,2 -u csv    # Display a line for each unique summary. \n");
        strcat(combo, "sortk -t, -k2,2 -y csv    # Do not remove binary.tmp \n");
        strcat(combo, "sortk -t, -k2,2 -y -%% csv # Produce manager.txt \n");
        strcat(combo, "sortk -t, -k2,2 -z256 csv # Use a buffer of 256 bytes. \n");
        strcat(combo, "sortk -t\\l -k2,2 file     # Wiki table \n");
        strcat(combo, "sortk -t\\l -k2,2 -x- csv  # Do not check if the file name includes .csv \n");
        strcat(combo, "sortk -t\\x7C -k2,2 file   # Wiki table \n");
        strcat(combo, "sortk -U131072 -k2,2 csv  # The number of lines shall not exceed 131072. \n");
        strcat(combo, "sortk -v\\x1F -k2,3 csv    # 1Fh connects phrases from Field-2 to Field-3. \n");
        strcat(combo, "sortk -w~ -k2,4 csv       # ~ is used as a quote. \n");
        strcat(combo, "sortk -V                  # version \n");
        strcat(combo, "sortk --help              # Display comments. \n");
        strcat(combo, "sortk -s --help > file    # Produce a help file. \n");
    } else {
        strcat(combo, "sortk --help \n");
    }

    if(loud) {
        fprintf(stderr, combo);
    } else { // -s
        fprintf(stdout, combo);
    }

    exit(1);
}
