#include "numbered.h"

BOOL trimmed_sequence(NUMBERED *n) {
    char *q;
    int size, u;
/*
a: -i1-37
first part of a: -i1-
second part of a: 37
trimmed sequence: -i1
first part of trimmed sequence: -i
second part of trimmed sequence: 1
*/

/* Trimming the first part of a */
    n->trimmed_sequence_length = strlen(n->f) - TRIMMING;
    n->pt = malloc( n->trimmed_sequence_length + 1 );
    memcpy(n->pt, n->f, n->trimmed_sequence_length);
    n->pt[n->trimmed_sequence_length] = '\0';
    u = strspn( strrev(n->pt), "0123456789");
    if(u == 0) {
        if(n->final == FINAL) {
            n->trimmed = FALSE;
        } else {   /* interval of 1 to 2147483646, for example */
            n->st = malloc(FINAL_SIZE_1);
            strcpy(n->st, n->s);

            size = strlen(n->f);
            n->ft = malloc( size + 1 );
            strcpy(n->ft, n->f);

            sprintf(n->s, "%d", n->final);

            n->trimmed = TRUE;
      }

    } else {
        n->span = u;
        n->non_number_length = n->trimmed_sequence_length - n->span;

/* Copying the second part of trimmed sequence */
        size = n->span + 1;
        n->st = malloc(size);

        q = & n->f[n->non_number_length];
        memcpy(n->st, q, n->span);
        n->st[n->span] = '\0';

/* Copying the first part of trimmed sequence */
        size = n->non_number_length + 1;
        n->ft = malloc(size);

        q = & n->f[0];
        memcpy(n->ft, q, n->non_number_length);
        n->ft[n->non_number_length] = '\0';

        n->trimmed = TRUE;
    }

    return n->trimmed;
}

void free_arrays(NUMBERED *n) {
    free(n->f);
    free(n->ft);
    free(n->p);
    free(n->pt);
    free(n->s);
    free(n->st);
}

char *parameter(NUMBERED *n) {
    if(n->trimmed) {
        return n->ft;
    } else {
        return n->f;
    }

}

void numbered(NUMBERED *n, char *a) {
    char *q;
    int size;

    n->pt = NULL;
    n->ft = NULL;
    n->st = NULL;
    n->trimmed = FALSE;

    n->final = FINAL;
    n->length = strlen(a);
    n->p = malloc( n->length + 1 );

/* Copying all */
    strcpy(n->p, a);
    n->span = strspn( strrev(n->p), "0123456789");
    n->non_number_length = n->length - n->span;

/* Copying the second part of a */
    size = n->span + 1;
    n->s = malloc(size);

    q = & a[n->non_number_length];
    memcpy(n->s, q, n->span);
    n->s[n->span] = '\0';

/* Copying the first part of a */
    size = n->non_number_length + 1;
    n->f = malloc(size);

    memcpy(n->f, a, n->non_number_length);
    n->f[n->non_number_length] = '\0';
}

void numbered_less_than_final(NUMBERED *n, char *a, int less_than_FINAL) {
    char *q;
    int size;

    n->pt = NULL;
    n->ft = NULL;
    n->st = NULL;
    n->trimmed = FALSE;

    n->final = less_than_FINAL;
    n->length = strlen(a);
    n->p = malloc( n->length + 1 );

/* Copying all */
    strcpy(n->p, a);
    n->span = strspn( strrev(n->p), "0123456789");
    n->non_number_length = n->length - n->span;

/* Copying the second part of a */
    size = n->span + 1;
    n->s = malloc(size);

    q = & a[n->non_number_length];
    memcpy(n->s, q, n->span);
    n->s[n->span] = '\0';

/* Copying the first part of a */
    size = n->non_number_length + 1;
    n->f = malloc(size);

    memcpy(n->f, a, n->non_number_length);
    n->f[n->non_number_length] = '\0';
}

int number(NUMBERED *n) {
    char *stop;
    int k = (int)strtol(n->s, &stop, 10);
    return k;
}

int subnumber(NUMBERED *n) {
    char *stop;
    int k = -1; /* error */

    if(n->trimmed) {
        k = (int)strtol(n->st, &stop, 10);
    }

    return k;
}
