#include "segmented.h"

BOOL STOP = TRUE;

static BOOL full_house[256] = {
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 
    TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE
};

BOOL attempt_to_provide_buffers(SEGMENTED *d, BOOL stop) {
    BOOL vain = FALSE;

    d->buffer = malloc(d->buffer_size);
    if(d->buffer == NULL) {
        vain = TRUE;
    }

    d->combo = malloc( MINIMUM_COMBO_SIZE + d->buffer_size );
    if(d->combo == NULL) {
        vain = TRUE;
    }

    d->selected = malloc( sizeof(BOOL) * ( d->field_count + 1 ) );
    if(d->selected == NULL) {
        vain = TRUE;
    } else {
        d->allocated = TRUE;
    }

    if(vain) {
        sprintf(d->messages, "malloc() error-8: %d bytes\n", d->buffer_size);

        if(stop) {
            fputs(d->messages, stderr);
            exit(1);
        }

    }

    return vain;
}

BOOL full_house_attempt_to_provide_buffers(SEGMENTED *d, BOOL stop) {
    BOOL vain = FALSE;

    d->buffer = malloc(d->buffer_size);
    if(d->buffer == NULL) {
        vain = TRUE;
    }

    d->combo = malloc( MINIMUM_COMBO_SIZE + d->buffer_size );
    if(d->combo == NULL) {
        vain = TRUE;
    }

    d->selected = full_house;
    d->allocated = FALSE;

    if(vain) {
        sprintf(d->messages, "malloc() error-9: %d bytes\n", d->buffer_size);

        if(stop) {
            fputs(d->messages, stderr);
            exit(1);
        }

    }

    return vain;
}

int search_separator(SEGMENTED *d, char *p, int beginning) {
    BOOL no_splitting = FALSE;
    int k, n;
    int s = NOT_RECOGNIZED;
    unsigned char uc;

    d->buffer[ d->buffer_size - 1 ] = '\0';
    strncpy(d->buffer, p, d->buffer_size - 1 );

    for(k = beginning; d->buffer[k]; k++) {
        uc = (unsigned char)d->buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == d->quote) {
                no_splitting = FALSE;
            }

            continue; /* Commas disappear if placed in quotes. */
        }

/* splitting */
        if(n == d->quote) {
            no_splitting = TRUE;
        } else if(n == d->separator) {
            s = k;
            break;
        }

    }

    return s;
}

int segmented_summary(SEGMENTED *d, char *p) {
    BOOL no_splitting = FALSE;
    char *q;
    int field_number = 1;
    int k, n;
    int m = 0;
    unsigned char uc;

    d->buffer[ d->buffer_size - 1 ] = '\0';
    strncpy(d->buffer, p, d->buffer_size - 1 );

    q = strchr(d->buffer, '\n');
    if(q == NULL) {
        if(d->buffer_size != UNBROKEN_BUFFER_SIZE) {
            sprintf(d->messages, "0Ah is not included in a buffer of %d bytes.\n", d->buffer_size);
            fputs(d->messages, stderr);
            exit(1);
        }

    } else {
        *q = '\0';
    }

    for(k = 0; d->buffer[k]; k++) {
        uc = (unsigned char)d->buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == d->quote) {
                no_splitting = FALSE;
                if(d->selected[field_number]) {
                    d->combo[m++] = d->buffer[k];
                }

            } else if(n == d->separator) {
                if(d->remove_separators) {
                    continue;
                } else {
                    if(d->selected[field_number]) {
                        d->combo[m++] = d->buffer[k];
                    }

                }

            } else {
                if(d->selected[field_number]) {
                    d->combo[m++] = d->buffer[k];
                }

            }

            continue;
        }

/* splitting */
        if(n == d->quote) {
            no_splitting = TRUE;
            if(d->selected[field_number]) {
                d->combo[m++] = d->buffer[k];
            }

        } else if(n == d->separator) {
            if(d->selected[field_number]) {
                d->combo[m++] = d->joint;
            }

            field_number += 1;
            if(field_number > d->field_count) {
                break;
            }

        } else {
            if(d->selected[field_number]) {
                d->combo[m++] = d->buffer[k];
            }

        }

    }

    d->combo[m] = '\0';
    if(d->combo[ m - 1 ] == d->joint) {
        field_number -= 1;
    }

    d->field_count = field_number;
    return field_number;
}

int segmented_summary_excludes_dakuten(SEGMENTED *d, char *p) {
    BOOL no_splitting = FALSE;
    char *q;
    int field_number = 1;
    int k, n;
    int m = 0;
    unsigned char uc;

    d->buffer[ d->buffer_size - 1 ] = '\0';
    strncpy(d->buffer, p, d->buffer_size - 1 );

    q = strchr(d->buffer, '\n');
    if(q == NULL) {
        if(d->buffer_size != UNBROKEN_BUFFER_SIZE) {
            sprintf(d->messages, "0Ah is not included in a buffer of %d bytes.\n", d->buffer_size);
            fputs(d->messages, stderr);
            exit(1);
        }

    } else {
        *q = '\0';
    }

    for(k = 0; d->buffer[k]; k++) {
        uc = (unsigned char)d->buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == d->quote) {
                no_splitting = FALSE;
                if(d->selected[field_number]) {
                    d->combo[m++] = d->buffer[k];
                }

            } else if(n == d->dakuten) {
                continue;
            } else if(n == d->handakuten) {
                continue;
            } else if(n == d->separator) {
                if(d->remove_separators) {
                    continue;
                } else {
                    if(d->selected[field_number]) {
                        d->combo[m++] = d->buffer[k];
                    }

                }

            } else {
                if(d->selected[field_number]) {
                    d->combo[m++] = d->buffer[k];
                }

            }

            continue;
        }

/* splitting */
        if(n == d->quote) {
            no_splitting = TRUE;
            if(d->selected[field_number]) {
                d->combo[m++] = d->buffer[k];
            }

        } else if(n == d->dakuten) {
            continue;
        } else if(n == d->handakuten) {
            continue;
        } else if(n == d->separator) {
            if(d->selected[field_number]) {
                d->combo[m++] = d->joint;
            }

            field_number += 1;
            if(field_number > d->field_count) {
                break;
            }

        } else {
            if(d->selected[field_number]) {
                d->combo[m++] = d->buffer[k];
            }

        }

    }

    d->combo[m] = '\0';
    if(d->combo[ m - 1 ] == d->joint) {
        field_number -= 1;
    }

    d->field_count = field_number;
    return field_number;
}

/*
#define connecting_fields                    connecting_P_Z_S_int_B
#define connecting_few_fields                connecting_P_Z_S_char_B
#define full_house_connecting_of_fields      connecting_Z_S_int_B
#define full_house_connecting_of_few_fields  connecting_Z_S_char_B
*/
void connecting_S(SEGMENTED *d, int s) {
    int m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->field_count = FIELD_COUNT;
    d->remove_separators = FALSE;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_S_B(SEGMENTED *d, int s, BOOL r) {
    int m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->field_count = FIELD_COUNT;
    d->remove_separators = r;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_S_char(SEGMENTED *d, int s, char f) {
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->remove_separators = FALSE;
    d->separator = s;

    full_house_attempt_to_provide_buffers(d, STOP);
}

void connecting_S_char_B(SEGMENTED *d, int s, char f, BOOL r) {
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->remove_separators = r;
    d->separator = s;

    full_house_attempt_to_provide_buffers(d, STOP);
}

void connecting_S_int(SEGMENTED *d, int s, int f) {
    int m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->remove_separators = FALSE;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_S_int_B(SEGMENTED *d, int s, int f, BOOL r) {
    int m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->remove_separators = r;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_Z_S(SEGMENTED *d, long z, int s) {
    int m;

    d->buffer_size = (int)z;
    d->field_count = FIELD_COUNT;
    d->remove_separators = FALSE;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_Z_S_B(SEGMENTED *d, long z, int s, BOOL r) {
    int m;

    d->buffer_size = (int)z;
    d->field_count = FIELD_COUNT;
    d->remove_separators = r;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_Z_S_char(SEGMENTED *d, long z, int s, char f) {
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = (int)z;
    d->remove_separators = FALSE;
    d->separator = s;

    full_house_attempt_to_provide_buffers(d, STOP);
}

void connecting_Z_S_char_B(SEGMENTED *d, long z, int s, char f, BOOL r) {
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = (int)z;
    d->remove_separators = r;
    d->separator = s;

    full_house_attempt_to_provide_buffers(d, STOP);
}

void connecting_Z_S_int(SEGMENTED *d, long z, int s, int f) {
    int m;

    d->buffer_size = (int)z;
    d->remove_separators = FALSE;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_Z_S_int_B(SEGMENTED *d, long z, int s, int f, BOOL r) {
    int m;

    d->buffer_size = (int)z;
    d->remove_separators = r;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for(m = 0; m < d->field_count; m++) {
        d->selected[ m + 1 ] = TRUE;
    }

}

void connecting_P_S_char(SEGMENTED *d, char *p, int s, char f) {
    int c, m;
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->pattern = p;
    d->remove_separators = FALSE;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_S_char_B(SEGMENTED *d, char *p, int s, char f, BOOL r) {
    int c, m;
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->pattern = p;
    d->remove_separators = r;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_S_int(SEGMENTED *d, char *p, int s, int f) {
    int c, m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->pattern = p;
    d->remove_separators = FALSE;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_S_int_B(SEGMENTED *d, char *p, int s, int f, BOOL r) {
    int c, m;

    d->buffer_size = UNBROKEN_BUFFER_SIZE;
    d->pattern = p;
    d->remove_separators = r;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_Z_S_char(SEGMENTED *d, char *p, long z, int s, char f) {
    int c, m;
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = (int)z;
    d->pattern = p;
    d->remove_separators = FALSE;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_Z_S_char_B(SEGMENTED *d, char *p, long z, int s, char f, BOOL r) {
    int c, m;
    unsigned char uc = (unsigned char)f;
    d->field_count = (int)uc; /* 0 to 255 */

    d->buffer_size = (int)z;
    d->pattern = p;
    d->remove_separators = r;
    d->separator = s;

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_Z_S_int(SEGMENTED *d, char *p, long z, int s, int f) {
    int c, m;

    d->buffer_size = (int)z;
    d->pattern = p;
    d->remove_separators = FALSE;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void connecting_P_Z_S_int_B(SEGMENTED *d, char *p, long z, int s, int f, BOOL r) {
    int c, m;

    d->buffer_size = (int)z;
    d->pattern = p;
    d->remove_separators = r;
    d->separator = s;

    d->field_count = f;
    if(d->field_count > FIELD_COUNT) {
        d->field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(d, STOP);

    for (m = 0; m < d->field_count; m++) {
        c = (int)p[m];
        d->selected[ m + 1 ] = (c == SET) ? TRUE : FALSE;
    }

}

void release_arrays(SEGMENTED *d) {
    free(d->buffer);
    free(d->combo);

    if(d->allocated) {
        free(d->selected);
    }

    d->buffer = NULL;
    d->combo = NULL;
    d->selected = NULL;
}

void supplying_bits(char *p, int *field_count) {
    if(*field_count > FIELD_COUNT) {
        *field_count = FIELD_COUNT;
    }

    memset(p, SET, *field_count);
}

void surge_of_set_bits(char *pattern, int field_count, int from, int to) {
/* 0011111000000000000, for example */
    char *p = pattern;
    int surge_length = to - from + 1;
    int from_1 = from - 1;

    if(surge_length > field_count) {
        surge_length = field_count;
        memset(pattern, SET, surge_length);
        pattern[surge_length] = '\0';
    } else {
        p[field_count] = '\0';
        memset(p, CLEAR, field_count);

        p += from_1;
        memset(p, SET, surge_length);
    }

}
