#ifndef SEGMENTED_H
#define SEGMENTED_H

#define connecting_fields                    connecting_P_Z_S_int_B
#define connecting_few_fields                connecting_P_Z_S_char_B
#define full_house_connecting_of_fields      connecting_Z_S_int_B
#define full_house_connecting_of_few_fields  connecting_Z_S_char_B
#define BELL 0x07
#define CLEAR '0'
#define FIELD_COUNT 3072
#define MESSAGES_SIZE 384
#define MINIMUM_COMBO_SIZE 256
#define NOT_RECOGNIZED -1
#define PATH_NAME_SIZE 255
#define QUOTE '"'
#define SET '1'
#define UNBROKEN_BUFFER_SIZE 524288 /* 512 KB */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bool_true.h"

typedef struct SEGMENTED SEGMENTED;
struct SEGMENTED {
    BOOL *selected;
    BOOL allocated, remove_separators;
    char *buffer;
    char *combo;
    char *pattern;
    char messages[MESSAGES_SIZE];
    int buffer_size, dakuten, field_count, handakuten, joint, quote, separator;
};

BOOL attempt_to_provide_buffers(SEGMENTED *d, BOOL stop);
BOOL full_house_attempt_to_provide_buffers(SEGMENTED *d, BOOL stop);
int search_separator(SEGMENTED *d, char *p, int beginning);
int segmented_summary(SEGMENTED *d, char *p);
int segmented_summary_excludes_dakuten(SEGMENTED *d, char *p);
void connecting_S(SEGMENTED *d, int s);
void connecting_S_B(SEGMENTED *d, int s, BOOL r);
void connecting_S_char(SEGMENTED *d, int s, char f);
void connecting_S_char_B(SEGMENTED *d, int s, char f, BOOL r);
void connecting_S_int(SEGMENTED *d, int s, int f);
void connecting_S_int_B(SEGMENTED *d, int s, int f, BOOL r);
void connecting_Z_S(SEGMENTED *d, long z, int s);
void connecting_Z_S_B(SEGMENTED *d, long z, int s, BOOL r);
void connecting_Z_S_char(SEGMENTED *d, long z, int s, char f);
void connecting_Z_S_char_B(SEGMENTED *d, long z, int s, char f, BOOL r);
void connecting_Z_S_int(SEGMENTED *d, long z, int s, int f);
void connecting_Z_S_int_B(SEGMENTED *d, long z, int s, int f, BOOL r);
void connecting_P_S_char(SEGMENTED *d, char *p, int s, char f);
void connecting_P_S_char_B(SEGMENTED *d, char *p, int s, char f, BOOL r);
void connecting_P_S_int(SEGMENTED *d, char *p, int s, int f);
void connecting_P_S_int_B(SEGMENTED *d, char *p, int s, int f, BOOL r);
void connecting_P_Z_S_char(SEGMENTED *d, char *p, long z, int s, char f);
void connecting_P_Z_S_char_B(SEGMENTED *d, char *p, long z, int s, char f, BOOL r);
void connecting_P_Z_S_int(SEGMENTED *d, char *p, long z, int s, int f);
void connecting_P_Z_S_int_B(SEGMENTED *d, char *p, long z, int s, int f, BOOL r);
void release_arrays(SEGMENTED *d);
void supplying_bits(char *p, int *field_count);
void surge_of_set_bits(char *pattern, int field_count, int from, int to);

#endif /* SEGMENTED_H */
