#include "sutai.h"

extern DOUBLE_UNION ZEROED;

static const int ERROR_CODE = -1;

int standard_input_binary_output(SELECTED *t, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted) {
    BOOL full_house = FALSE;
    char *buffer;
    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    SEGMENTED s;
    SEGMENTED *d = &s;
    int buffer_size = (int)z;
    int buffer_size_1 = buffer_size - 1;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        fprintf(stderr, "fopen() error-6: %s\n", TEMPORARY_BINARY);
        t->exit_code = 8;
        return ERROR_CODE;
    }

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;

    t->line_count = 0;
    t->record_size = END + buffer_size;
    if(t->record_size > BLOCK_SIZE) {
        fprintf(stderr, "t->record_size > BLOCK_SIZE error: %d bytes\n", t->record_size);
        t->exit_code = 9;
        return ERROR_CODE;
    }

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-11: %d bytes\n", buffer_size);
        t->exit_code = 10;
        return ERROR_CODE;
    }

    p = strchr(bits, CLEAR);
    if(p == NULL) {
        full_house = TRUE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
/*                building_double_array = copying_summary; */
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                segmented_summary(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            d->dakuten = 'P';
            d->handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                segmented_summary_excludes_dakuten(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    }

    fclose(binary_file);
    free(buffer);
    return t->line_count;
}

int standard_input_binary_output_adding_ID(SELECTED *t, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted) {
    BOOL full_house = FALSE;
    char *buffer;
    char *p;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    SEGMENTED s;
    SEGMENTED *d = &s;
    int buffer_size = (int)z;
    int buffer_size_1 = buffer_size - 1;
    FILE *binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        fprintf(stderr, "fopen() error-7: %s\n", TEMPORARY_BINARY);
        t->exit_code = 11;
        return ERROR_CODE;
    }

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;

    t->line_count = 0;
    t->record_size = END + buffer_size;
    if(t->record_size > BLOCK_SIZE) {
        fprintf(stderr, "t->record_size > BLOCK_SIZE error: %d bytes\n", t->record_size);
        t->exit_code = 12;
        return ERROR_CODE;
    }

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-12: %d bytes\n", buffer_size);
        t->exit_code = 13;
        return ERROR_CODE;
    }

    p = strchr(bits, CLEAR);
    if(p == NULL) {
        full_house = TRUE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
/*                building_double_array = copying_summary; */
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                segmented_summary(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                n->n[LINE_ID] = t->line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            d->dakuten = 'P';
            d->handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                segmented_summary_excludes_dakuten(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                n->n[LINE_ID] = t->line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    }

    fclose(binary_file);
    free(buffer);
    return t->line_count;
}
