#include "sutai.h"

int BELL_ASCII_KATAKANA[BELL_ASCII_KATAKANA_COUNT] = {
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, 
    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, 
    0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 
    0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, 
    0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 
    0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 
    0x07, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 
    0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF, 
    0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 
    0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 0xDF
};

extern DOUBLE_UNION ZEROED;

static char sjis[END];
static const int ERROR_CODE = -1;

int selecting(SELECTED *t, char *file_name, char *pattern, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted) {
    BOOL full_house = FALSE;
    char *buffer;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    SEGMENTED s;
    SEGMENTED *d = &s;
    FILE *binary_file;
    FILE *file;
    int buffer_size = (int)z;
    int buffer_size_1 = buffer_size - 1;
    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? TRUE : FALSE;

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-13: %d bytes\n", buffer_size);
        t->exit_code = 14;
        return ERROR_CODE;
    }

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;

    binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        fprintf(stderr, "fopen() error-8: %s\n", TEMPORARY_BINARY);
        t->exit_code = 15;
        return ERROR_CODE;
    }

    t->line_count = 0;
    t->record_size = END + buffer_size;
    if(t->record_size > BLOCK_SIZE) {
        fprintf(stderr, "t->record_size > BLOCK_SIZE error: %d bytes\n", t->record_size);
        t->exit_code = 16;
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        error_handler("fopen() error-9:", file_name);
        t->exit_code = 17;
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
/*                building_double_array = copying_summary; */
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, pattern, z, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, pattern, z, separator, field_count, remove_separators);
                segmented_summary(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            d->dakuten = 'P';
            d->handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, pattern, z, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    p = & n->c[END];
                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, pattern, z, separator, field_count, remove_separators);
                segmented_summary_excludes_dakuten(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                p = & n->c[END];
                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    }

    fclose(file);
    fclose(binary_file);
    free(buffer);
    return t->line_count;
}

int selecting_adding_ID(SELECTED *t, char *file_name, char *pattern, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted) {
    BOOL full_house = FALSE;
    char *buffer;
    char few_fields;
    DOUBLE_ARRAY_FUNCTION building_double_array = copying_summary;
    DOUBLE_UNION u = ZEROED;
    DOUBLE_UNION *n = &u;
    SEGMENTED s;
    SEGMENTED *d = &s;
    FILE *file;
    FILE *binary_file;
    int buffer_size = (int)z;
    int buffer_size_1 = buffer_size - 1;
    char *p = strchr(pattern, CLEAR);
    full_house = (p == NULL) ? TRUE : FALSE;

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-14: %d bytes\n", buffer_size);
        t->exit_code = 18;
        return ERROR_CODE;
    }

    d->dakuten = 0xDE;
    d->handakuten = 0xDF;
    d->joint = joint;
    d->quote = quote;

    binary_file = fopen(TEMPORARY_BINARY, "wb");
    if(binary_file == NULL) {
        fprintf(stderr, "fopen() error-10: %s\n", TEMPORARY_BINARY);
        t->exit_code = 19;
        return ERROR_CODE;
    }

    t->line_count = 0;
    t->record_size = END_ID + buffer_size;
    if(t->record_size > BLOCK_SIZE) {
        fprintf(stderr, "t->record_size > BLOCK_SIZE error: %d bytes\n", t->record_size);
        t->exit_code = 20;
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        error_handler("fopen() error-11:", file_name);
        t->exit_code = 21;
        return ERROR_CODE;
    }

    if(assume_shift_jis_appears) {
        manager = PHRASES;
        if(skip_space) {
            building_double_array = skipping_Shift_JIS_copying;
        } else {
            building_double_array = Shift_JIS_copying;
        }

    } else {
        if(skip_space) {
            manager = PHRASES;
            building_double_array = skipping_copying;
        } else {
            switch(manager) {
            case PHRASES:
/*                building_double_array = copying_summary; */
                break;
            case INTEGERS:
                building_double_array = copying_integers;
                break;
            case FLOATING_POINT_NUMBERS:
                building_double_array = copying_doubles;
                break;
            default:
                building_double_array = copying_summary;
                break;
            }

        }

    }

    if(combining_character) {
        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, pattern, z, separator, few_fields, remove_separators);
                    segmented_summary(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, pattern, z, separator, field_count, remove_separators);
                segmented_summary(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                n->n[LINE_ID] = t->line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    } else {
        if(substituted) {
            d->dakuten = 'P';
            d->handakuten = 'Q';
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    full_house_connecting_of_few_fields(d, z, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    t->line_count += 1;
                    if(t->line_count > upper_limit) {
                        break;
                    }

                    connecting_few_fields(d, pattern, z, separator, few_fields, remove_separators);
                    segmented_summary_excludes_dakuten(d, buffer);
                    building_double_array(n, d); /* summary */
                    release_arrays(d);

                    n->n[LINE_ID] = t->line_count;
                    p = & n->c[END];
                    p += WIDE_SPACE_SIZE;

                    p[buffer_size_1] = '\0';
                    strncpy(p, buffer, buffer_size_1); /* details */

                    fwrite(n->c, t->record_size, 1, binary_file);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                t->line_count += 1;
                if(t->line_count > upper_limit) {
                    break;
                }

                connecting_fields(d, pattern, z, separator, field_count, remove_separators);
                segmented_summary_excludes_dakuten(d, buffer);
                building_double_array(n, d); /* summary */
                release_arrays(d);

                n->n[LINE_ID] = t->line_count;
                p = & n->c[END];
                p += WIDE_SPACE_SIZE;

                p[buffer_size_1] = '\0';
                strncpy(p, buffer, buffer_size_1); /* details */

                fwrite(n->c, t->record_size, 1, binary_file);
            }

        }

    }

    fclose(file);
    fclose(binary_file);
    free(buffer);
    return t->line_count;
}

void copying_doubles(DOUBLE_UNION *n, SEGMENTED *d) {
    char *stop;
    int k;
    int wide_space = strcspn(d->combo, "-.0123456789");
    char *p = & d->combo[wide_space];

    memset(n->c, 0, END);
    for(k = 0; k < DOUBLE_ARRAY_SIZE; k++) {
        n->d[k] = strtod(p, &stop);
        p = strchr(p, d->joint);
        if(p == NULL) {
            break;
        }

        p++;
    }
}

void copying_integers(DOUBLE_UNION *n, SEGMENTED *d) {
    char *stop;
    int k;
    int wide_space = strcspn(d->combo, "-0123456789");
    char *p = & d->combo[wide_space];

    memset(n->c, 0, END);
    for(k = 0; k < INTEGER_ARRAY_SIZE; k++) {
        n->n[k] = (int)strtol(p, &stop, 10);
        p = strchr(p, d->joint);
        if(p == NULL) {
            break;
        }

        p++;
    }
}

void copying_summary(DOUBLE_UNION *n, SEGMENTED *d) {
    n->c[END_1] = '\0';
    strncpy(n->c, d->combo, END_1);
}

void Shift_JIS_copying(DOUBLE_UNION *n, SEGMENTED *d) {
    BOOL kanji = FALSE;
    int c = 0x40;
    int i;
    int k = 0;
    unsigned char uc;
    unsigned char firstByte = 0x40;

    sjis[END_1] = '\0';
    strncpy(sjis, d->combo, END_1);

    for(i = 0; sjis[i]; ++i) {
        uc = (unsigned char) sjis[i];
        c = (int)uc;

        if(kanji) {
            n->c[k] = firstByte;
            n->c[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = FALSE;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c <= KANA_DAKUTEN) {
                n->c[k] = (char)uc;
                k += KATAKANA_SIZE;
            } else {
                firstByte = uc;
                kanji = TRUE;
            }

        } else {
            c = BELL_ASCII_KATAKANA[c];
            if(c == BELL) {
                continue; /* skipping control characters */
            } else {
                n->c[k++] = (char)uc;
            }

        }

    } /* for(i = 0; sjis[i]; ++i) */

    n->c[k] = '\0';
}

void skipping_copying(DOUBLE_UNION *n, SEGMENTED *d) {
    int wide_space = strspn(d->combo, " ");
    char *p = & d->combo[wide_space];

    n->c[END_1] = '\0';
    strncpy(n->c, p, END_1);
}

void skipping_Shift_JIS_copying(DOUBLE_UNION *n, SEGMENTED *d) {
    BOOL kanji = FALSE;
    int c = 0x40;
    int i;
    int k = 0;
    unsigned char uc;
    unsigned char firstByte = 0x40;
    int wide_space = strspn(d->combo, " ");
    char *p = & d->combo[wide_space];

    sjis[END_1] = '\0';
    strncpy(sjis, p, END_1);

    for(i = 0; sjis[i]; ++i) {
        uc = (unsigned char) sjis[i];
        c = (int)uc;

        if(kanji) {
            n->c[k] = firstByte;
            n->c[ k + 1 ] = (char)uc;
            k += ZENKAKU_SIZE;
            kanji = FALSE;
            continue;
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c <= KANA_DAKUTEN) {
                n->c[k] = (char)uc;
                k += KATAKANA_SIZE;
            } else {
                firstByte = uc;
                kanji = TRUE;
            }

        } else {
            c = BELL_ASCII_KATAKANA[c];
            if(c == BELL) {
                continue; /* skipping control characters */
            } else {
                n->c[k++] = (char)uc;
            }

        }

    } /* for(i = 0; sjis[i]; ++i) */

    n->c[k] = '\0';
}
