#ifndef SUTAI_H /* SUmmary and deTAIls (SUTAI) */
#define SUTAI_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#pragma warn -8071
#endif

#define VERSION 1.11
#define BELL_ASCII_KATAKANA_COUNT 224
#define BLOCK_SIZE 3072
#define BUFFER_SIZE 524288 /* 512 KB */
#define COMMA ','
#define DOUBLE_ARRAY_SIZE 10
#define END 80 /* SIZE_OF_DOUBLE * DOUBLE_ARRAY_SIZE = END */
#define END_1 79 /* END - 1 */
#define END_ID 91 // END + WIDE_SPACE_SIZE
#define ERROR_TEXT "error.txt"
#define HE 0xCD /* "" Shift_JIS */
#define INTEGER_ARRAY_SIZE 20
#define KANA_DAKUTEN 0xDE
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KATAKANA_SIZE 1
#define LIMIT_OF_MY_MEMORY 128
#define LINE_ID INTEGER_ARRAY_SIZE
#define MAXIMUM_SIZE_OF_ENCODED_PATTERN 641 /* END * 8 bits + 1 */
#define PATTERN_OF_32_BITS 32
#define SETTING_TEXT "manager.txt"
#define SIZE_OF_DOUBLE 8 /* sizeof(double) = 8 */
#define SMALL_BUFFER 16
#define SMALL_BUFFER_1 15 /* SMALL_BUFFER - 1 */
#define SUTAI_TEXT "sutai.txt"
#define TEMPORARY_BINARY "binary.tmp"
#define UPPER_LIMIT 16384
#define WIDE_SPACE_SIZE 11 /* FINAL_SIZE_1 */
#define ZENKAKU_SIZE 2
#include <search.h> /* qsort() */
#include "line.h"
#include "numbered.h"
#include "segmented.h"

enum LIST_OF_FUNCTIONS {
    PHRASES,
    INTEGERS,
    FLOATING_POINT_NUMBERS,
    FUNCTION_COUNT
};

typedef struct SELECTED SELECTED;
struct SELECTED {
    int exit_code, line_count, record_size;
};

typedef union DOUBLE_UNION DOUBLE_UNION;
union DOUBLE_UNION {
    char c[BLOCK_SIZE];
    double d[DOUBLE_ARRAY_SIZE];
    int n[ INTEGER_ARRAY_SIZE + 1 ];
};

typedef void (*DOUBLE_ARRAY_FUNCTION)(DOUBLE_UNION *n, SEGMENTED *d);

BOOL producing(char *new_name, char *records_list, int end, int line_count, int record_size, BOOL carriage_return);
char *BOOL_line(int lineNumber, BOOL b);
int arranging_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, BOOL add_ID, BOOL carriage_return, BOOL case_sensitive, BOOL descending);
int arranging_unique_lines_to_produce_text(char *file_name, char *new_name, int line_count, int manager, int record_size, BOOL add_ID, BOOL carriage_return, BOOL case_sensitive, BOOL descending);
int case_insensitive_comparison(const void *x, const void *y);
int case_insensitive_comparison_descending(const void *x, const void *y);
int compare_doubles(const void *x, const void *y);
int compare_doubles_descending(const void *x, const void *y);
int compare_integers(const void *x, const void *y);
int compare_integers_descending(const void *x, const void *y);
int compare_phrases(const void *x, const void *y);
int compare_phrases_descending(const void *x, const void *y);
int punctuation(char *p, int q);
int run_length_encoding(DOUBLE_UNION *u, char *combo, int combo_size);
int counting(SELECTED *s, char *file_name, char *bits, long z, int separator, int field_count, int joint, int quote, int upper_limit, BOOL remove_separators);
int selecting(SELECTED *s, char *file_name, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted);
int selecting_adding_ID(SELECTED *s, char *file_name, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted);
int standard_input_binary_output(SELECTED *s, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted);
int standard_input_binary_output_adding_ID(SELECTED *s, char *bits, long z, int separator, int field_count, int joint, int manager, int quote, int upper_limit, BOOL assume_shift_jis_appears, BOOL combining_character, BOOL remove_separators, BOOL skip_space, BOOL substituted);
int standard_input_counting(SELECTED *s, char *bits, long z, int separator, int field_count, int joint, int quote, int upper_limit, BOOL remove_separators);
void copying_doubles(DOUBLE_UNION *n, SEGMENTED *d);
void copying_integers(DOUBLE_UNION *n, SEGMENTED *d);
void copying_summary(DOUBLE_UNION *n, SEGMENTED *d);
void display_records(char *records_list, int end, int line_count, int record_size);
void error_handler(const char *p, char *q);
void producing_text(const char *parameters_text, char *file_name, char *new_name, int line_count, int manager, int record_size, BOOL add_ID, BOOL case_sensitive, BOOL report_ID, BOOL carriage_return, BOOL descending, BOOL loud, BOOL remove_temporary_binary_file, BOOL unique_summary);
void Shift_JIS_copying(DOUBLE_UNION *n, SEGMENTED *d);
void skipping_copying(DOUBLE_UNION *n, SEGMENTED *d);
void skipping_Shift_JIS_copying(DOUBLE_UNION *n, SEGMENTED *d);
void version_guide(double v, BOOL comments, BOOL loud);

#endif /* SUTAI_H */
